/*
 * Copyright (C) 2013 Snowsun <http://wyrez.org> and contributors
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */
package org.wyrez.shootingstars.states;

import com.jme3.app.state.AbstractAppState;
import com.jme3.app.state.AppStateManager;
import java.io.File;
import javax.swing.JFileChooser;
import org.wyrez.shootingstars.game.GameSettings;
import org.wyrez.shootingstars.gui.SelectTrackGUI;
import org.wyrez.shootingstars.gui.listener.SelectFileListener;
import tonegod.gui.core.Screen;

/**
 *
 * @author Snowsun
 */
public class SelectTrackState extends AbstractAppState implements SelectFileListener {

    private StateManager stateManager;
    private GameSettings settings;
    private SelectTrackGUI gui;

    public SelectTrackState(Screen screen, StateManager stateManager, GameSettings settings) {
        this.stateManager = stateManager;
        this.settings = settings;
        this.gui = new SelectTrackGUI(screen, this);
    }

    @Override
    public void stateAttached(AppStateManager stateManager) {
        gui.attach();
    }

    @Override
    public void stateDetached(AppStateManager stateManager) {
        gui.detach();
    }

    public void selectFile() {
        JFileChooser jFileChooser = new JFileChooser();
        int returnVal = jFileChooser.showOpenDialog(null);

        if (returnVal == JFileChooser.APPROVE_OPTION) {
            File file = jFileChooser.getSelectedFile();
            settings.setVideoFile(file.getPath());
            stateManager.setState(State.FILEMETAINFO);
        }
    }

    public void downloadYT() {
        stateManager.setState(State.YTDOWNLOAD);
    }

    public void cancel() {
        stateManager.setState(State.MENU);
    }
}
